package com.pault;

import org.xml.sax.*;
import java.net.URL;
import java.io.*;

import org.xml.sax.InputSource;
import com.jclark.xml.sax.CommentDriver;

/**
 * Creation date: (7/25/00 3:47:07 PM)
 * @author: Paul Tchistopolskii
 *
 * This is wrapper for good old XT.
 *
 */
 
public class X extends com.jclark.xml.sax.CommentDriver {


	public void parse(org.xml.sax.InputSource ins) throws 
		java.io.IOException, org.xml.sax.SAXException {

			String sysid =  ins.getSystemId();			

			// System.err.println( "sysid: " + sysid );	
			String result =  "EMPTY";
			
			if ( sysid.endsWith( ".xsls" ) ) {

				try {

					InputStreamReader input = 
							new InputStreamReader( new URL(sysid).openStream() );

					result = 
						com.pault.xslscript.XSLScriptParser.Load( input );

					InputSource newins = 
						new InputSource ( new ByteArrayInputStream( result.getBytes() ) );

					newins.setSystemId( ins.getSystemId() );

					super.parse( newins );

					newins = null;
						
				} catch ( SAXParseException e ) {
					
					String err = "";

					String systemId =  ( (SAXParseException) e).getSystemId();
					int lineNumber = ( (SAXParseException) e).getLineNumber();
					if (systemId != null)
					  err += systemId + ":";
					if (lineNumber >= 0)
					  err += lineNumber + ":";
	
					if (systemId != null || lineNumber >= 0)
	  				  err += " ";

			  		err += ( (SAXParseException) e).getMessage() + "\n";
			  		err += "XSLScript has generated weird XSL code:"  + "\n";
			  		err += result;

					throw new org.xml.sax.SAXException( err.toString() );
	
				}
				
				catch ( Exception ee ) {

					throw new org.xml.sax.SAXException( ee.toString() );
				}

				return;
			}
			
			super.parse( ins );
	}
}
